rotateVec_CustomAxis: axis, theta		// theta radian
{
	// credit: Sang Hoon
	
	// rotates a vector along a vector-defined axis; returns the 3*3 rotatino matrix (e.g. getFoward(), getUp(), getRight())

	var r[3][3];
	
	st = sin(theta);
	ct = cos(theta);

	w1 = axis.x;
	w2 = axis.y;
	w3 = axis.z;

	r[1][1] = 1 - (1-ct)* (w2*w2 + w3*w3);
	r[2][1] = w3 * st + (1-ct)*w1*w2;
	r[3][1] = -1 * w2 * st + (1-ct)*w3 * w1;

	r[1][2] = -1 * w3 * st + (1-ct)*w1*w2;
	r[2][2] = 1 - (1-ct) * (w3*w3+w1*w1);
	r[3][2] = w1 * st + (1-ct) * w2 * w3;

	r[1][3] = w2 * st + (1-ct)*w3 * w1;
	r[2][3] = -1 * w1 * st + (1-ct) * w2 * w3;
	r[3][3] = 1 - (1-ct) * (w1*w1 + w2*w2);

	return r;
}
